
#include <ESP8266WiFi.h>
#include <PubSubClient.h>

  
String command; // serial input capture string
String clientName;
const char* ssid = "internet";
const char* password = "";
const char* mqtt_server = "192.168.168.150";

uint32_t runTime = -99999;

//--topics
String input1 = "weather/humidex";  // weewex
String input2 = "weather/outTemp_C"; // weewex
String input3 = "weather/windchill_C"; // weewex
String input4 = "/energy/solar";   //energy monitor ie oem 
String input5 = "/energy/grid";    //energy monitor ie oem 
String input6 = "/energy/divertA";    //energy monitor ie oem 
String input7 = "weather/windSpeed_kph";  // weewex
String input8 = "/ai/date";    // date  from AI interface 
String input9 = "/ai/time";    // time  from AI interface
String input10 = "/ai/offlight"; //
String input11 = "/ai/onlight";   // used for data tect clear 
String input12 = "/ai/station"; //info box top
String input13 = "/ai/artist";  //info box middle
String input14 = "/ai/song";    //info box bottom
String input15 = "/ai/clear";    // clear  info area
String input16 = "/ai/data";    //ai text box
String input17 = "/input/IN1";  // weather descrip
String input18 = "/input/IN2";  //weather high
String input19 = "/input/IN3";  // weather low 
String input20 = "/input/IN4"; // forecast descrip
String input21 = "/input/IN5";  //forecast high
String input22 = "/input/IN6";  // forecast low 
String input23 = "/input/IN7";  
String input24 = "/input/IN8";  
String input25 = "/input/IN9";  
String input26 = "/input/IN10";  
String input27 = "/input/IN11";  
String input28 = "/input/IN12";  
String input29 = "/energy/input1"; //solar panel 1
String input30 = "/energy/input2"; //solar panel 2
String input31 = "/energy/input3"; //solar panel 3
String input32 = "/energy/input4"; //solar panel 4
String input33 = "/energy/input5"; //solar panel 5
String input34 = "/energy/input6";
String input35 = "/energy.input7";
String input36 = "/energy/input8";
String input37 = "/input/IN13";  // battery level and SOC
String input38 = "/input/IN14";    
String input39 = "/input/IN15";   
String input40 = "/input/IN16";   
String input41 = "/input/IN17";   
String input42 = "/input/IN18";  
String input43 = "/input/IN19";
String input44 = "/input/IN20";
String input45 = "/input/IN21";
String input46 = "/input/IN22";
String input47 = "/input/IN23";
String input48 = "/input/IN24";
String input49 = "/input/IN25";
String input50 = "/input/IN26";
// Update these with values suitable for your network.



WiFiClient espClientTFT32;
PubSubClient client(espClientTFT32);
long lastMsg = 0;
char msg[50];
int value = 0;

void setup() {
  pinMode(BUILTIN_LED, OUTPUT);     // Initialize the BUILTIN_LED pin as an output
  Serial.begin(115200);
  setup_wifi();
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);
 // weather(); // built in weather underground 
}

void setup_wifi() {
WiFi.hostname("espTFTScreen32");
  delay(10);
WiFi.mode(WIFI_STA);   
  // We start by connecting to a WiFi network
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  clientName += "esp8266-";
  uint8_t mac[6];
  WiFi.macAddress(mac);
  clientName += macToStr(mac);
  clientName += "-";
  clientName += String(micros() & 0xff, 16);
  
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  Serial.println(clientName);
}

void callback(char* topic, byte* payload, unsigned int length) {


if (input1 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
  Serial.print("cmd_1("); Serial.print(inString); Serial.println(")");
  }
if (input2 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);  
  }
   Serial.print("cmd_2("); Serial.print(inString); Serial.println(")");
} 
 if (input3 == topic){
  String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
   Serial.print("cmd_3("); Serial.print(inString); Serial.println(")");
  }
if (input4 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
  Serial.print("cmd_4("); Serial.print(inString); Serial.println(")");  
} 
if (input5 == topic){
  String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);     
  }
 Serial.print("cmd_5("); Serial.print(inString); Serial.println(")"); 
} 
//---reseved for later use 

if (input6 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);   
  }
  Serial.print("cmd_6("); Serial.print(inString); Serial.println(")");
  }
if (input7 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);      
  }
   Serial.print("cmd_7("); Serial.print(inString); Serial.println(")");
} 
 if (input8 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);    
  }
  Serial.print("cmd_8("); Serial.print(inString); Serial.println(")");
  }
if (input9 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
  Serial.print("cmd_9("); Serial.print(inString); Serial.println(")");    
} 
if (input10 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
     Serial.print("cmd_10("); Serial.print(inString); Serial.println(")");
      
} 

if (input11 == topic){
  String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
     Serial.print("cmd_11("); Serial.print(inString); Serial.println(")");
  }
  }
if (input12 == topic){
String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  } 
     Serial.print("cmd_12("); Serial.print(inString); Serial.println(")");
} 
 if (input13 == topic){
  String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
     Serial.print("cmd_13("); Serial.print(inString); Serial.println(")");
  }
if (input14 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);  
  }
     Serial.print("cmd_14("); Serial.print(inString); Serial.println(")");
} 
if (input15 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
     Serial.print("cmd_15("); Serial.print(inString); Serial.println(")");
} 

 if (input16 == topic){
  String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
     Serial.print("cmd_16("); Serial.print(inString); Serial.println(")");
  }
if (input17 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  } 
     Serial.print("cmd_17("); Serial.print(inString); Serial.println(")");
} 
 if (input18 == topic){
  String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
     Serial.print("cmd_18("); Serial.print(inString); Serial.println(")");
  }
if (input19 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  } 
     Serial.print("cmd_19("); Serial.print(inString); Serial.println(")");
} 
if (input20 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
     Serial.print("cmd_20("); Serial.print(inString); Serial.println(")");
      
} 

if (input21 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
  Serial.print("cmd_21("); Serial.print(inString); Serial.println(")");
  }
if (input22 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);  
  }
   Serial.print("cmd_22("); Serial.print(inString); Serial.println(")");
} 
 if (input23 == topic){
  String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
   Serial.print("cmd_23("); Serial.print(inString); Serial.println(")");
  }
if (input24 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
  Serial.print("cmd_24("); Serial.print(inString); Serial.println(")");  
} 
if (input25 == topic){
  String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);     
  }
 Serial.print("cmd_25("); Serial.print(inString); Serial.println(")"); 
} 
//---reseved for later use 

if (input26 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);   
  }
  Serial.print("cmd_26("); Serial.print(inString); Serial.println(")");
  }
if (input27 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);      
  }
   Serial.print("cmd_27("); Serial.print(inString); Serial.println(")");
} 
 if (input28 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);    
  }
  Serial.print("cmd_28("); Serial.print(inString); Serial.println(")");
  }
if (input29 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
  Serial.print("cmd_29("); Serial.print(inString); Serial.println(")");    
} 
if (input30 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
     Serial.print("cmd_30("); Serial.print(inString); Serial.println(")");
      
} 

if (input31 == topic){
  String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
     Serial.print("cmd_31("); Serial.print(inString); Serial.println(")");
  }
  }
if (input32 == topic){
String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  } 
     Serial.print("cmd_32("); Serial.print(inString); Serial.println(")");
} 
 if (input33 == topic){
  String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
     Serial.print("cmd_33("); Serial.print(inString); Serial.println(")");
  }
if (input34 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);  
  }
     Serial.print("cmd_34("); Serial.print(inString); Serial.println(")");
} 
if (input35 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
     Serial.print("cmd_35("); Serial.print(inString); Serial.println(")");
} 

 if (input36 == topic){
  String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
     Serial.print("cmd_36("); Serial.print(inString); Serial.println(")");
  }
if (input37 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  } 
     Serial.print("cmd_37("); Serial.print(inString); Serial.println(")");
} 
 if (input38 == topic){
  String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
     Serial.print("cmd_38("); Serial.print(inString); Serial.println(")");
  }
if (input39 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  } 
     Serial.print("cmd_39("); Serial.print(inString); Serial.println(")");
} 
if (input40 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
     Serial.print("cmd_40("); Serial.print(inString); Serial.println(")");
      
} 

if (input41 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
  Serial.print("cmd_41("); Serial.print(inString); Serial.println(")");
  }
if (input42 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);  
  }
   Serial.print("cmd_42("); Serial.print(inString); Serial.println(")");
} 
 if (input43 == topic){
  String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
   Serial.print("cmd_43("); Serial.print(inString); Serial.println(")");
  }
if (input44 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
  Serial.print("cmd_44("); Serial.print(inString); Serial.println(")");  
} 
if (input45 == topic){
  String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);     
  }
 Serial.println("cmd_45(0)");// Serial.print(inString); Serial.println(")"); 
} 
//---reseved for later use 

if (input46 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);   
  }
  Serial.println("cmd_46(1)"); //Serial.print(inString); Serial.println(")");
  }
if (input47 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);      
  }
   Serial.print("cmd_47("); Serial.print(inString); Serial.println(")");
} 
 if (input48 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);    
  }
  Serial.print("cmd_48("); Serial.print(inString); Serial.println(")");
  }
if (input49 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
  Serial.print("cmd_49("); Serial.print(inString); Serial.println(")");    
} 
if (input50 == topic){
 String inString = "";
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]); 
  }
     Serial.println("cmd_50(1)"); //Serial.print(inString); Serial.println(")");
      
} 
/// if adding more sensor strings edit publish or remove publish and error commands below for switches 

 
  // Switch on the LED if an 1 was received as first character
  if ((char)payload[0] == '1') {
    digitalWrite(BUILTIN_LED, LOW);   // Turn the LED on (Note that LOW is the voltage level
    // but actually the LED is on; this is because
    // it is acive low on the ESP-01)
  } else {
    digitalWrite(BUILTIN_LED, HIGH);  // Turn the LED off by making the voltage HIGH
  }

}
String macToStr(const uint8_t* mac)
{
  String result;
  for (int i = 0; i < 6; ++i) {
    result += String(mac[i], 16);
    if (i < 5)
      result += ':';
  }
  return result;
}
void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.print("Attempting MQTT connection...");
    // Attempt to connect
    if (client.connect((char*) clientName.c_str())) {
      Serial.println("connected");
      // Once connected, publish an announcement...
      client.publish("outTopic", "hello world");
      // ... and resubscribe maxium 7 other wise issues arise
      //client.subscribe("/grid");
      //client.subscribe("/wind");
      client.subscribe("/input/#");
      client.subscribe("/ai/#");
      //client.subscribe("/switch/#");
      client.subscribe("/energy/#");
      client.subscribe("weather/#");

     
     
    } else {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 5 seconds before retrying
      delay(2000);
    }
  }
}
///////////


//////////////
void loop() {
//if(WiFi.status() != WL_CONNECTED) {setup_wifi();}
  if (!client.connected()) {
    reconnect();
 }
  client.loop();
  
  

   if(Serial.available())
   {
      char c = Serial.read();
    
      if (c == ')')
      {
       
        parseCommand(command);
        
        command="";
      }
      else
      {
       command += c;
      }
  }

}


void parseCommand(String com)
{

//--com variables  
char test[5];
  String part1;
  String part2;
  Serial.println(com);
  
  part1 = com.substring(4, com.indexOf("(")); // some issues @ (6 or 4 , com.indexOf("("))
  //int test = part1.toInt();
  Serial.print(part1);
  Serial.print(" # ");
  part2 = com.substring(com.indexOf("(")+1);
  Serial.println(part2);

//--output 1-9 
//////////////////////  
  if (part1 == "_100")
  {
    String raw_CMD = part2;
         if (client.connected()){
    if (client.publish("/switch/SW0", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }
  if (part1 == "100")
  {
    String raw_CMD = part2;
         if (client.connected()){
    if (client.publish("/switch/SW0", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }
  if (part1== "101")
    {
      //Serial.println(part2);
     String raw_CMD = part2;
            if (client.connected()){
     if (client.publish("/switch/SW1", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
  }

 if (part1 == "102")
    {
     // Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
     if (client.publish("/switch/SW2", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
  }

  if (part1 == "103")
  {
    String raw_CMD = part2;
    if (client.connected()){
    if (client.publish("/switch/SW3", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
       }
  if (part1== "104")
    {
     // Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
     if (client.publish("/switch/SW4", (char*) raw_CMD.c_str())) {
     Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

    if (part1== "105")
    {
      //Serial.println(part2);
      String raw_CMD = part2;
   if (client.connected()){
     if (client.publish("/switch/SW5", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
   }
    }
    if (part1== "106")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW6", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

        if (part1== "107")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW7", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

        if (part1== "108")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW8", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

        if (part1== "109")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW9", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

    //--output 10 -19
//////////////////////  

  if (part1 == "110")
  {
    String raw_CMD = part2;
         if (client.connected()){
    if (client.publish("/switch/SW10", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }
  if (part1== "111")
    {
      //Serial.println(part2);
     String raw_CMD = part2;
            if (client.connected()){
     if (client.publish("/switch/SW11", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
  }

 if (part1 == "112")
    {
     // Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
     if (client.publish("/switch/SW12", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
  }

  if (part1 == "113")
  {
    String raw_CMD = part2;
    if (client.connected()){
    if (client.publish("/switch/SW13", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
       }
  if (part1== "114")
    {
     // Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
     if (client.publish("/switch/SW14", (char*) raw_CMD.c_str())) {
     Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

    if (part1== "115")
    {
      //Serial.println(part2);
      String raw_CMD = part2;
   if (client.connected()){
     if (client.publish("/switch/SW15", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
   }
    }
    if (part1== "116")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SWl6", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

        if (part1== "117")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW17", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

        if (part1== "118")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW18", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

        if (part1== "119")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW19", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

   //--output 20 -29
//////////////////////  

  if (part1 == "120")
  {
    String raw_CMD = part2;
         if (client.connected()){
    if (client.publish("/switch/SW20", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }
  if (part1== "121")
    {
      //Serial.println(part2);
     String raw_CMD = part2;
            if (client.connected()){
     if (client.publish("/switch/SW21", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
  }

 if (part1 == "122")
    {
     // Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
     if (client.publish("/switch/SW22", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
  }

  if (part1 == "123")
  {
    String raw_CMD = part2;
    if (client.connected()){
    if (client.publish("/switch/SW23", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
       }
  if (part1== "124")
    {
     // Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
     if (client.publish("/switch/SW24", (char*) raw_CMD.c_str())) {
     Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

    if (part1== "125")
    {
      //Serial.println(part2);
      String raw_CMD = part2;
   if (client.connected()){
     if (client.publish("/switch/SW25", (char*) raw_CMD.c_str())) {
      Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
   }
    }
    if (part1== "126")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW26", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

        if (part1== "127")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW27", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

        if (part1== "128")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW28", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }

        if (part1== "129")
    {
     //Serial.println(part2);
      String raw_CMD = part2;
          if (client.connected()){
  
    if (client.publish("/switch/SW29", (char*) raw_CMD.c_str())) {
       Serial.println("cmd_51(published)");
      digitalWrite(BUILTIN_LED, LOW);
    }
    else {
      Serial.println("cmd_52(failed)");
    }
     }
    }
/////////////    
}
